<template>
  <div>
    <div class="flex items-center justify-between xs:items-start gap-8 xs:flex-col">
      <p class="font-bold text-lg leading-5 sm:text-base xs:text-base text-txtdprim">
        {{ $t('endpoint.get-connect') }}
      </p>
      <UiTab :options="options" v-model="currentOption" class="xs:w-full" />
    </div>
    <div
      class="nodecode__code-view p-4 mt-8 sm:mt-4 xs:mt-4 bg-bgdtert rounded-24"
      :class="{ 'nodecode__code-view_animated': loading }"
    >
      <div class="bg-bgdsec flex items-center px-2.5 gap-2 h-12 rounded-12">
        <img width="20" height="20" src="@/assets/images/views/endpoint/curl.svg" />
        <p class="grow font-medium text-sm leading-5 text-txtdsec">{{ currentOption.title }}</p>
        <div v-if="!loading" class="w-0.5 h-3 rounded-100 bg-brdddef"></div>
        <div
          class="px-3 text-txtdsec hover:text-txtdprim active:text-txtdprim active:bg-btndsec rounded-12 font-medium text-sm leading-5 h-8 cursor-pointer flex justify-center items-center"
          @mousedown.prevent
          @click="copyText"
        >
          {{ isValueCopied ? $t('endpoint.copied') : $t('endpoint.copy') }}
        </div>
      </div>
      <div class="mt-4 relative">
        <div
          ref="codeWrapper"
          class="relative p-4 overflow-scroll nodecode__code-area"
          :class="{ 'nodecode__code-area_not-loading': !loading }"
        >
          <div
            v-if="!loading"
            ref="codeText"
            class="mt-2 text-txtdsec font-medium text-sm leading-5 w-max min-w-full"
            v-html="currentCode"
          ></div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import UiTab from '@/components/ui/UiTab.vue';

export default {
  name: 'NodeCode',

  components: { UiTab },

  props: {
    nodeInfo: {
      type: Object,
      default: () => ({}),
    },

    loading: {
      type: Boolean,
      default: false,
    },
  },

  data() {
    return {
      options: [
        {
          title: 'Curl',
          value: 'curl',
        },
        {
          title: 'Go',
          value: 'go',
        },
        {
          title: 'Web3.js',
          value: 'js',
        },
        {
          title: 'Python',
          value: 'python',
        },
      ],

      currentOption: {
        title: 'Curl',
        value: 'curl',
      },

      isValueCopied: false,
      copyTimeout: null,
    };
  },

  computed: {
    endpointLink() {
      if (!this.nodeInfo.api_key) return '';
      return `https://${this.nodeInfo.prefix}.flashnodes.io/v1/${this.nodeInfo.cryptocurrency_symbol.toLowerCase()}/${
        this.nodeInfo.network
      }/${this.nodeInfo.mode}/${this.nodeInfo.api_key}/`;
    },

    currentCode() {
      if (this.currentOption.value === 'go')
        return `<span class="italic">package</span> main<br /><br /><span class="italic">import </span><span class="text-purple-code">(</span><br /><span class="text-green-code pl-6 inline-block">"context"<br />"fmt"<br />"github.com/ethereum/go-ethereum/ethclient"</span><br /><span class="text-purple-code">)</span><br /><br /><span class="italic">func</span> <span class="text-blue-code">main</span><span class="text-purple-code">( ) {</span><br /><span class="pl-6 inline-block"><span class="italic">const</span> <span class="text-green-code">url = "${this.endpointLink}"</span><br/><br/>rpcClient<span class="text-purple-code">,</span>err := ethclient.<span class="text-blue-code">Dial</span><span class="text-purple-code">(</span>url<span class="text-purple-code">)</span><br/><br/><span class="italic">if</span> err != <span class="text-red-code">nil</span> <span class="text-purple-code">{</span><br/><span class="inline-block pl-6"><span class="text-blue-code">panic</span><span class="text-purple-code">(</span>err<span class="text-purple-code">)</span></span><br/><span class="text-purple-code">}</span><br/><br/>blockNumber<span class="text-purple-code">,</span> err := rpcClient.<span class="text-blue-code">BlockNumber</span><span class="text-purple-code">(</span>context.<span class="text-blue-code">Background</span><span class="text-purple-code">())</span><br/><br/><span class="italic">if</span> err != <span class="text-red-code">nil</span> <span class="text-purple-code">{</span><br/><span class="inline-block pl-6"><span class="text-blue-code">panic</span><span class="text-purple-code">(</span>err<span class="text-purple-code">)</span></span><br/><span class="text-purple-code">}</span><br/><br/>fmt.<span class="text-blue-code">Println</span><span class="text-purple-code">(</span>blockNumber<span class="text-purple-code">)</span></span><br/><span class="text-purple-code">}</span>`;
      if (this.currentOption.value === 'js')
        return `<span class="italic">const</span> Web3 = <span class="text-blue-code">require</span><span class="text-purple-code">(</span><span class="text-green-code">'web3'</span><span class="text-purple-code">);</span><br/><br/><span class="italic">const</span> url = <span class="text-green-code">'${this.endpointLink}'</span>;<br/><br/><span class="italic">const</span> web3 = <span class="italic">new</span> <span class="text-yellow-code">Web3</span><span class="text-purple-code">(</span><span class="italic">new</span> <span class="text-yellow-code">Web3.providers.HttpProvider</span><span class="text-purple-code">(</span>url<span class="text-purple-code">));</span><br/><br/>web3.eth.<span class="text-blue-code">getBlockNumber</span><span class="text-purple-code">((</span>error, blockNumber<span class="text-purple-code">)</span> => <span class="text-purple-code">{</span><br/><br/><span class="inline-block pl-6"><span class="italic">if</span> <span class="text-purple-code">(</span>!error<span class="text-purple-code">) {</span><br/><span class="inline-block pl-6"><span class="text-yellow-code">console</span>.<span class="text-blue-code">log</span><span class="text-purple-code">(</span>blockNumber<span class="text-purple-code">);</span></span><br/><span class="text-purple-code">}</span> <span class="italic">else</span> <span class="text-purple-code">{</span><br/><span class="inline-block pl-6"><span class="text-yellow-code">console</span>.<span class="text-blue-code">log</span><span class="text-purple-code">(</span>error<span class="text-purple-code">);</span></span><br/><span class="text-purple-code">}</span></span><br/><span class="text-purple-code">});</span>`;
      if (this.currentOption.value === 'python')
        return `<span class="italic">from</span> web3 <span class="italic">import</span> Web3<br/><br/><span class="italic">def </span> <span class="text-blue-code">test_block_number</span><span class="text-purple-code">(</span>self<span class="text-purple-code">):</span><br/><span class="inline-block pl-6">url = <span class="text-green-code">'${this.endpointLink}'</span><br/><br/>web3 = Web3<span class="text-purple-code">(</span>HTTPProvider<span class="text-purple-code">(</span>url<span class="text-purple-code">))</span><br/><span class="italic">print</span><span class="text-purple-code">(</span>web3.eth.block_number<span class="text-purple-code">)</span></span>`;
      return `<span class="font-medium text-sm leading-5 text-txtdtert"># bash</span><br /><br /><span class="text-blue-code">curl</span> -X POST ${this.endpointLink} -d <span class="text-green-code">'{"jsonrpc":"2.0","method":"eth_blockNumber","params":[],"id":1}'</span>`;
    },

    // currentCode2() {
    //   if (this.currentOption.value === 'go')
    //     return `package main<br /><br />import(<br /><span class="pl-6 inline-block">"context"<br />"fmt"<br />"github.com/ethereum/go-ethereum/ethclient"</span><br />)<br /><br />func main() {<br /><span class="pl-6 inline-block">const url = "${this.endpointLink}"<br/><br/>rpcClient,err := ethclient.Dial(url)<br/><br/>if err != nil {<br/><span class="inline-block pl-6">panic(err)</span><br/>}<br/><br/>blockNumber, err := rpcClient.BlockNumber(context.Background())<br/><br/>if err != nil {<br/><span class="inline-block pl-6">panic(err)</span><br/>}<br/><br/>fmt.Println(blockNumber)</span><br/>}`;
    //   if (this.currentOption.value === 'js')
    //     return `const Web3 = require('web3');<br/><br/>const url = '${this.endpointLink}';<br/><br/>const web3 = new Web3(new Web3.providers.HttpProvider(url));<br/><br/>web3.eth.getBlockNumber((error, blockNumber) => {<br/><br/><span class="inline-block pl-6">if (!error) {<br/><span class="inline-block pl-6">console.log(blockNumber);</span><br/>} else {<br/><span class="inline-block pl-6">console.log(error);</span><br/>}</span><br/>});`;
    //   if (this.currentOption.value === 'python')
    //     return `from web3 import Web3<br/><br/>def test_block_number(self):<br/><span class="inline-block pl-6">url = '${this.endpointLink}'<br/><br/>web3 = Web3(HTTPProvider(url))<br/>print(web3.eth.block_number)</span>`;
    //   return `<span class="font-medium text-sm leading-5 text-txtdtert"># bash</span><br /><br />curl -X POST ${this.endpointLink} -d '{"jsonrpc":"2.0","method":"eth_blockNumber","params":[],"id":1}'`;
    // },

    currentCodeValue() {
      if (this.currentOption.value === 'go')
        return `package main\n\nimport(\n"context"\n"fmt"\n"github.com/ethereum/go-ethereum/ethclient"\n)\n\nfunc main() {\nconst url = "${this.endpointLink}"\n\nrpcClient,err := ethclient.Dial(url)\n\nif err != nil {\npanic(err)\n}\n\nblockNumber, err := rpcClient.BlockNumber(context.Background())\n\nif err != nil {\npanic(err)\n}\n\nfmt.Println(blockNumber)\n}`;
      if (this.currentOption.value === 'js')
        return `const Web3 = require('web3');\n\nconst url = '${this.endpointLink}';\n\nconst web3 = new Web3(new Web3.providers.HttpProvider(url));\n\nweb3.eth.getBlockNumber((error, blockNumber) => {\n\nif (!error) {\nconsole.log(blockNumber);\n} else {\nconsole.log(error);\n}\n});`;
      if (this.currentOption.value === 'python')
        return `from web3 import Web3\n\ndef test_block_number(self):\nurl = '${this.endpointLink}'\n\nweb3 = Web3(HTTPProvider(url))\nprint(web3.eth.block_number)`;
      return `curl -X POST ${this.endpointLink} -d '{"jsonrpc":"2.0","method":"eth_blockNumber","params":[],"id":1}'`;
    },
  },

  methods: {
    copyTextIos() {
      const wrapper = this.$refs.codeWrapper;
      const textArea = document.createElement('textArea');
      textArea.style.position = 'absolute';
      textArea.style.opacity = '0';
      textArea.setAttribute('readonly', true);
      textArea.value = this.currentCodeValue;
      wrapper.appendChild(textArea);

      const range = document.createRange();
      range.selectNodeContents(textArea);
      const selection = window.getSelection();
      selection.removeAllRanges();
      selection.addRange(range);
      textArea.setSelectionRange(0, 999999);

      document.execCommand('copy');
      wrapper.removeChild(textArea);
    },

    async copyTextPc() {
      await navigator.clipboard.writeText(this.currentCodeValue);
    },

    async copyText() {
      const isIOS = navigator.userAgent.match(/ipad|iphone/i);
      try {
        if (isIOS) this.copyTextIos();
        else await this.copyTextPc();
        if (this.copyTimeout) clearTimeout(this.copyTimeout);
        this.isValueCopied = true;
        this.copyTimeout = setTimeout(() => {
          this.isValueCopied = false;
        }, 3000);
      } catch (err) {
        console.error('[CopyText Error]');
        console.error(err);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.nodecode {
  &__code-view {
    height: 226px;

    &_animated {
      animation-duration: 2s;
      animation-fill-mode: forwards;
      animation-iteration-count: infinite;
      animation-name: loading-animation;
      animation-timing-function: linear;
      background-color: #f6f7f8;
      background: linear-gradient(to right, #17283e 8%, #111e2f 50%, #17283e 100%);
      background-size: 800px;
    }
  }

  &__code-area {
    height: 130px;

    &::-webkit-scrollbar {
      width: 0px;
      height: 0px;
    }

    &_not-loading {
      scrollbar-width: thin;
      scrollbar-color: #17283e #132235;

      &::-webkit-scrollbar {
        width: 8px;
        height: 8px;
        margin-top: 8px;
      }

      &::-webkit-scrollbar-thumb {
        background: #17283e;
        border-radius: 10px;
        cursor: pointer;
        margin-top: 8px;
      }

      &::-webkit-scrollbar-corner {
        display: none;
      }

      &::-webkit-scrollbar-track {
        background: #132235;
      }
    }
  }
}

@keyframes loading-animation {
  0% {
    background-position: -800px 0;
  }
  100% {
    background-position: 800px 0;
  }
}
</style>
